"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _ArrayValidator_instances, _ArrayValidator_validationTasks, _ArrayValidator_optional, _ArrayValidator_rule, _ArrayValidator_addValidation;
Object.defineProperty(exports, "__esModule", { value: true });
const AnyValidator_1 = __importDefault(require("./AnyValidator"));
const AllValidator_1 = __importDefault(require("./AllValidator"));
const Utils_1 = __importStar(require("./Utils"));
/**
 * Validator for Array parameters, which includes multiple Array validation methods.
 */
class ArrayValidator extends AllValidator_1.default {
    constructor(v) {
        super();
        _ArrayValidator_instances.add(this);
        _ArrayValidator_validationTasks.set(this, []);
        _ArrayValidator_optional.set(this, false);
        _ArrayValidator_rule.set(this, void 0);
        this.output = {};
        const any = new AnyValidator_1.default();
        __classPrivateFieldSet(this, _ArrayValidator_rule, v || any, "f");
        this.isOptional = false;
        __classPrivateFieldGet(this, _ArrayValidator_instances, "m", _ArrayValidator_addValidation).call(this, Utils_1.default.array());
    }
    optional() {
        __classPrivateFieldSet(this, _ArrayValidator_optional, true, "f");
        // ts-ignore
        return this;
    }
    minLength(min) {
        __classPrivateFieldGet(this, _ArrayValidator_instances, "m", _ArrayValidator_addValidation).call(this, Utils_1.default.minLength(min));
        return this;
    }
    maxLength(max) {
        __classPrivateFieldGet(this, _ArrayValidator_instances, "m", _ArrayValidator_addValidation).call(this, Utils_1.default.maxLength(max));
        return this;
    }
    test(p) {
        if ((0, Utils_1.isEmptyValue)(p)) {
            return __classPrivateFieldGet(this, _ArrayValidator_optional, "f");
        }
        for (const fn of __classPrivateFieldGet(this, _ArrayValidator_validationTasks, "f")) {
            if (!fn(p))
                return false;
        }
        if (__classPrivateFieldGet(this, _ArrayValidator_rule, "f")) {
            for (const v of p) {
                if (!__classPrivateFieldGet(this, _ArrayValidator_rule, "f").test(v)) {
                    this.errText(__classPrivateFieldGet(this, _ArrayValidator_rule, "f").getErrText());
                    return false;
                }
                ;
            }
        }
        return true;
    }
}
_ArrayValidator_validationTasks = new WeakMap(), _ArrayValidator_optional = new WeakMap(), _ArrayValidator_rule = new WeakMap(), _ArrayValidator_instances = new WeakSet(), _ArrayValidator_addValidation = function _ArrayValidator_addValidation(fn) {
    __classPrivateFieldGet(this, _ArrayValidator_validationTasks, "f").push(fn);
};
exports.default = ArrayValidator;
