"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _NumberValidator_instances, _NumberValidator_validationTasks, _NumberValidator_optional, _NumberValidator_nullable, _NumberValidator_addValidation;
Object.defineProperty(exports, "__esModule", { value: true });
const AllValidator_1 = __importDefault(require("./AllValidator"));
const Utils_1 = __importStar(require("./Utils"));
/**
 * Validator for Number parameters, which includes multiple Number validation methods.
 */
class NumberValidator extends AllValidator_1.default {
    constructor() {
        super();
        _NumberValidator_instances.add(this);
        _NumberValidator_validationTasks.set(this, []);
        _NumberValidator_optional.set(this, false);
        _NumberValidator_nullable.set(this, false);
        this.output = 0;
        __classPrivateFieldGet(this, _NumberValidator_instances, "m", _NumberValidator_addValidation).call(this, Utils_1.default.number());
    }
    optional() {
        __classPrivateFieldSet(this, _NumberValidator_optional, true, "f");
        return this;
    }
    nullable() {
        __classPrivateFieldSet(this, _NumberValidator_nullable, true, "f");
        return this;
    }
    /**
     * Set minimum value of a number.
     * Returns true if number >= min.
     * @param {number} min minimum value
     * @returns {NumberValidator} NumberValidator
     */
    min(min) {
        __classPrivateFieldGet(this, _NumberValidator_instances, "m", _NumberValidator_addValidation).call(this, Utils_1.default.min(min));
        return this;
    }
    /**
     * Set maximum value of a number.
     * Returns true if number <= max.
     * @param {number} max maximum value
     * @returns {NumberValidator} NumberValidator
     */
    max(max) {
        __classPrivateFieldGet(this, _NumberValidator_instances, "m", _NumberValidator_addValidation).call(this, Utils_1.default.max(max));
        return this;
    }
    /**
     * Check if a number is an integer.
     * Returns true if number is an integer.
     * @returns {NumberValidator} NumberValidator
     */
    int() {
        __classPrivateFieldGet(this, _NumberValidator_instances, "m", _NumberValidator_addValidation).call(this, Utils_1.default.int());
        return this;
    }
    /**
     * Check if number is positive.
     * Returns true if number >= 0.
     * @returns {NumberValidator} NumberValidator
     */
    positive() {
        __classPrivateFieldGet(this, _NumberValidator_instances, "m", _NumberValidator_addValidation).call(this, Utils_1.default.positive());
        return this;
    }
    /**
     * Check if number is negative.
     * Returns true if number <= 0.
     * @returns {NumberValidator} NumberValidator
     */
    negative() {
        __classPrivateFieldGet(this, _NumberValidator_instances, "m", _NumberValidator_addValidation).call(this, Utils_1.default.negative());
        return this;
    }
    /**
     * Check if number is a positive integer.
     * Returns true if the number is a positive integer.
     * @returns {NumberValidator} NumberValidator
     */
    id() {
        __classPrivateFieldGet(this, _NumberValidator_instances, "m", _NumberValidator_addValidation).call(this, Utils_1.default.id());
        return this;
    }
    /**
     * Set fixed length of a float number.
     * Returns true if the fixed length equals.
     * @param {number} len fixed length
     * @returns {NumberValidator} NumberValidator
     */
    toFixed(len) {
        __classPrivateFieldGet(this, _NumberValidator_instances, "m", _NumberValidator_addValidation).call(this, Utils_1.default.toFixed(len));
        return this;
    }
    /**
     * Check if number is one of the array elements.
     * Returns true if the number is in the array.
     * @param {number[]} arr number set
     * @returns {NumberValidator} NumberValidator
     */
    oneof(arr) {
        __classPrivateFieldGet(this, _NumberValidator_instances, "m", _NumberValidator_addValidation).call(this, Utils_1.default.oneof(arr));
        return this;
    }
    test(p) {
        if ((0, Utils_1.isEmptyValue)(p)) {
            return __classPrivateFieldGet(this, _NumberValidator_optional, "f");
        }
        if (Number.isNaN(p) && !__classPrivateFieldGet(this, _NumberValidator_nullable, "f")) {
            return false;
        }
        for (const fn of __classPrivateFieldGet(this, _NumberValidator_validationTasks, "f")) {
            if (!fn(p))
                return false;
        }
        return true;
    }
}
_NumberValidator_validationTasks = new WeakMap(), _NumberValidator_optional = new WeakMap(), _NumberValidator_nullable = new WeakMap(), _NumberValidator_instances = new WeakSet(), _NumberValidator_addValidation = function _NumberValidator_addValidation(fn) {
    __classPrivateFieldGet(this, _NumberValidator_validationTasks, "f").push(fn);
};
exports.default = NumberValidator;
