"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _ObjectValidator_instances, _ObjectValidator_validationTasks, _ObjectValidator_optional, _ObjectValidator_rules, _ObjectValidator_addValidation;
Object.defineProperty(exports, "__esModule", { value: true });
const AllValidator_1 = __importDefault(require("./AllValidator"));
const Utils_1 = __importStar(require("./Utils"));
/**
 * Validator for Boolean parameters, which includes multiple Boolean validation methods.
 */
class ObjectValidator extends AllValidator_1.default {
    constructor(v) {
        super();
        _ObjectValidator_instances.add(this);
        _ObjectValidator_validationTasks.set(this, []);
        _ObjectValidator_optional.set(this, false);
        _ObjectValidator_rules.set(this, void 0);
        this.output = v || {};
        __classPrivateFieldSet(this, _ObjectValidator_rules, v, "f");
        this.isOptional = false;
        __classPrivateFieldGet(this, _ObjectValidator_instances, "m", _ObjectValidator_addValidation).call(this, Utils_1.default.object());
    }
    optional() {
        __classPrivateFieldSet(this, _ObjectValidator_optional, true, "f");
        return this;
    }
    test(p) {
        if ((0, Utils_1.isEmptyValue)(p)) {
            return __classPrivateFieldGet(this, _ObjectValidator_optional, "f");
        }
        for (const fn of __classPrivateFieldGet(this, _ObjectValidator_validationTasks, "f")) {
            if (!fn(p))
                return false;
        }
        if (__classPrivateFieldGet(this, _ObjectValidator_rules, "f")) {
            for (const name in __classPrivateFieldGet(this, _ObjectValidator_rules, "f")) {
                const validator = __classPrivateFieldGet(this, _ObjectValidator_rules, "f")[name];
                if (!validator.test(p[name])) {
                    this.errText(validator.getErrText());
                    return false;
                }
            }
        }
        return true;
    }
}
_ObjectValidator_validationTasks = new WeakMap(), _ObjectValidator_optional = new WeakMap(), _ObjectValidator_rules = new WeakMap(), _ObjectValidator_instances = new WeakSet(), _ObjectValidator_addValidation = function _ObjectValidator_addValidation(fn) {
    __classPrivateFieldGet(this, _ObjectValidator_validationTasks, "f").push(fn);
};
exports.default = ObjectValidator;
