export interface IValidator {
    result: () => boolean;
    errText: (text: string) => void;
    error: () => Error;
}
export type ValidateFunction = (value: any, option?: any) => boolean;
export type UtilFunction = (option?: any) => ValidateFunction;
export interface IUtils {
    number: UtilFunction;
    boolean: UtilFunction;
    string: UtilFunction;
    object: UtilFunction;
    array: UtilFunction;
    oneof: UtilFunction;
    min: UtilFunction;
    max: UtilFunction;
    int: UtilFunction;
    positive: UtilFunction;
    negative: UtilFunction;
    id: UtilFunction;
    toFixed: UtilFunction;
    minLength: UtilFunction;
    maxLength: UtilFunction;
    numeric: UtilFunction;
    booleanStr: UtilFunction;
    useRE: UtilFunction;
    email: UtilFunction;
    phone: UtilFunction;
    date: UtilFunction;
}
