"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../src/index");
const assert_1 = __importDefault(require("assert"));
let v;
exports.default = () => {
    // Array Checks
    try {
        console.log('==========');
        v = 'array';
        const a1 = (0, index_1.array)().errText('array required');
        assert_1.default.strictEqual(a1.test(v), false, 'test array-1 fails');
        v = ['array'];
        const a2 = (0, index_1.array)().errText('array required');
        assert_1.default.strictEqual(a2.test(v), true, 'test array-2 fails');
        v = undefined;
        const a3 = (0, index_1.array)().optional().errText('array required');
        assert_1.default.strictEqual(a3.test(v), true, 'test array-3 fails');
        v = ['array'];
        const a4 = (0, index_1.array)((0, index_1.string)()).optional().errText('array required');
        assert_1.default.strictEqual(a4.test(v), true, 'test array-4 fails');
        v = ['1', '2'];
        const a5 = (0, index_1.array)((0, index_1.string)()).optional().minLength(3).errText('array min len 3');
        assert_1.default.strictEqual(a5.test(v), false, 'test array-5 fails');
        assert_1.default.strictEqual(a5.getErrText(), 'array min len 3', 'test array-5 fails');
        v = [1, 2];
        const a6 = (0, index_1.array)((0, index_1.string)()).optional();
        assert_1.default.strictEqual(a6.test(v), false, 'test array-5 fails');
        console.log('\x1B[32m%s\x1B[0m', 'Array tests passed!');
        console.log('==========');
    }
    catch (error) {
        console.log(error);
    }
};
