"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../src/index");
const assert_1 = __importDefault(require("assert"));
let v;
exports.default = () => {
    // Helper Checks
    try {
        console.log("==========");
        v = "1";
        const a1 = (0, index_1.or)([(0, index_1.string)(), (0, index_1.number)()]).errText("string or number");
        assert_1.default.ok(a1.test(v), "test or-1 fails");
        v = 2;
        const a2 = (0, index_1.or)([(0, index_1.string)(), (0, index_1.number)()]).errText("string or number");
        assert_1.default.ok(a2.test(v), "test or-2 fails");
        v = true;
        const a3 = (0, index_1.or)([(0, index_1.string)(), (0, index_1.number)()]).errText("string or number");
        assert_1.default.ok(!a3.test(v), "test or-3 fails");
        v = true;
        const a4 = (0, index_1.or)([
            (0, index_1.string)(),
            (0, index_1.object)({
                id: (0, index_1.number)(),
                name: (0, index_1.string)().optional(),
            }),
        ]).errText("string or object");
        assert_1.default.ok(!a4.test(v), "test or-4 fails");
        v = undefined;
        const a5 = (0, index_1.or)([
            (0, index_1.string)(),
            (0, index_1.object)({
                id: (0, index_1.number)(),
                name: (0, index_1.string)().optional(),
            }),
        ]).errText("string or object");
        assert_1.default.ok(!a5.test(v), "test or-5 fails");
        v = "true";
        const a6 = (0, index_1.and)([
            (0, index_1.object)({
                id: (0, index_1.number)(),
                name: (0, index_1.number)().optional(),
            }),
            (0, index_1.object)({
                id: (0, index_1.number)(),
                name: (0, index_1.string)().optional(),
            }),
        ]).errText("string or object");
        assert_1.default.ok(!a6.test(v), "test and-6 fails");
        console.log("\x1B[32m%s\x1B[0m", "Helper tests passed!");
        console.log("==========");
    }
    catch (error) {
        console.log(error);
    }
};
