"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../src/index");
const assert_1 = __importDefault(require("assert"));
let v;
let o;
exports.default = () => {
    // Object Checks
    try {
        console.log('==========');
        v = undefined;
        const o1 = (0, index_1.object)().optional().errText('no require array');
        assert_1.default.ok(o1.test(v), 'test object-1 fails');
        v = '1';
        o = (0, index_1.object)().errText('type error');
        assert_1.default.ok(!o.test(v), 'test object-2 fails');
        v = 1;
        o = (0, index_1.object)({
            'x': (0, index_1.boolean)().optional(),
            'y': (0, index_1.boolean)().errText('y type error!'),
        }).errText('type error');
        assert_1.default.ok(!o.test(v), 'test object-3 fails');
        v = { x: true, y: 2 };
        assert_1.default.ok(!o.test(v), 'test object-4 fails');
        assert_1.default.equal(o.getErrText(), 'y type error!', 'test object-4 fails');
        v = { x: true };
        assert_1.default.equal(o.test(v), false, 'test object-5 fails');
        v = { y: false };
        assert_1.default.ok(o.test(v), 'test object-6 fails');
        o = (0, index_1.object)({
            'x': (0, index_1.boolean)().optional(),
            'y': (0, index_1.object)({
                'a1': (0, index_1.string)().errText('a1 is required'),
                'a2': (0, index_1.string)().optional()
            })
        });
        v = {
            x: undefined,
            y: {
                a1: 'a1',
            }
        };
        assert_1.default.ok(o.test(v), 'test object-7 fails');
        v = {
            y: {
                a2: 'a2',
            }
        };
        assert_1.default.equal(o.test(v), false, 'test object-8 fails');
        assert_1.default.equal(o.getErrText(), 'a1 is required', 'test object-8 fails');
        v = undefined;
        assert_1.default.ok(!o.test(v), 'test object-9 fails');
        console.log('\x1B[32m%s\x1B[0m', 'Object tests passed!');
        console.log('==========');
    }
    catch (error) {
        console.log(error);
    }
};
